package jez04.structure.test;

import static org.hamcrest.MatcherAssert.assertThat;

import java.net.URISyntaxException;

import org.junit.jupiter.params.ParameterizedTest;
import org.junit.jupiter.params.provider.CsvSource;

import cz.vsb.fei.kelvin.unittest.StructureHelper;
import cz.vsb.fei.kelvin.unittest.TextFileContains;

class ClassStructureTest {

	StructureHelper helper = StructureHelper.getInstance(ClassStructureTest.class);

	// @formatter:off
	@ParameterizedTest
	@CsvSource({
			"Score.java,@MyEdit,4",
			"EditController.java,Introspector.getBeanInfo,1",
			"EditController.java,BeanInfo,1",
			"EditController.java,PropertyDescriptor,1",
			"EditController.java,getDeclaredField,1",
			"EditController.java,getAnnotation,1",
			"EditController.java,\\.readOnly\\(\\),1",
			"EditController.java,\\.visible\\(\\),1",
			"MyEdit.java,@interface,1",
			"MyEdit.java,@Retention,1",
			"MyEdit.java,RetentionPolicy\\.RUNTIME,1",
			"MyEdit.java,readOnly\\(\\),1",
			"MyEdit.java,visible\\(\\),1",
			"msg(_.*)?\\.properties,points,2",
		})
	// @formatter:on
	void anotaceTest(String file, String annotation, int count) throws URISyntaxException {
		assertThat(TextFileContains.getProjectRoot(getClass()), new TextFileContains(file, annotation).count(count).useRegExpForName(true));
	}


}
